/* source-base-view.c generated by valac 0.10.0, the Vala compiler
 * generated from source-base-view.vala, do not modify */

/*
 * Copyright (c) 2010, Nate Stedman <natesm@gmail.com>
 * 
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>


#define SOURCE_TYPE_BASE_VIEW (source_base_view_get_type ())
#define SOURCE_BASE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOURCE_TYPE_BASE_VIEW, SourceBaseView))
#define SOURCE_BASE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOURCE_TYPE_BASE_VIEW, SourceBaseViewClass))
#define SOURCE_IS_BASE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOURCE_TYPE_BASE_VIEW))
#define SOURCE_IS_BASE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOURCE_TYPE_BASE_VIEW))
#define SOURCE_BASE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOURCE_TYPE_BASE_VIEW, SourceBaseViewClass))

typedef struct _SourceBaseView SourceBaseView;
typedef struct _SourceBaseViewClass SourceBaseViewClass;
typedef struct _SourceBaseViewPrivate SourceBaseViewPrivate;

#define SOURCE_TYPE_LIST (source_list_get_type ())
#define SOURCE_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOURCE_TYPE_LIST, SourceList))
#define SOURCE_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOURCE_TYPE_LIST, SourceListClass))
#define SOURCE_IS_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOURCE_TYPE_LIST))
#define SOURCE_IS_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOURCE_TYPE_LIST))
#define SOURCE_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOURCE_TYPE_LIST, SourceListClass))

typedef struct _SourceList SourceList;
typedef struct _SourceListClass SourceListClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define SOURCE_TYPE_BASE_GROUP (source_base_group_get_type ())
#define SOURCE_BASE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOURCE_TYPE_BASE_GROUP, SourceBaseGroup))
#define SOURCE_BASE_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOURCE_TYPE_BASE_GROUP, SourceBaseGroupClass))
#define SOURCE_IS_BASE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOURCE_TYPE_BASE_GROUP))
#define SOURCE_IS_BASE_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOURCE_TYPE_BASE_GROUP))
#define SOURCE_BASE_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOURCE_TYPE_BASE_GROUP, SourceBaseGroupClass))

typedef struct _SourceBaseGroup SourceBaseGroup;
typedef struct _SourceBaseGroupClass SourceBaseGroupClass;

struct _SourceBaseView {
	GtkAlignment parent_instance;
	SourceBaseViewPrivate * priv;
	GtkAlignment* bin;
	SourceList* list;
};

struct _SourceBaseViewClass {
	GtkAlignmentClass parent_class;
};


static gpointer source_base_view_parent_class = NULL;

GType source_base_view_get_type (void) G_GNUC_CONST;
GType source_list_get_type (void) G_GNUC_CONST;
enum  {
	SOURCE_BASE_VIEW_DUMMY_PROPERTY,
	SOURCE_BASE_VIEW_LIST_WIDTH_REQUEST
};
SourceBaseView* source_base_view_construct (GType object_type);
SourceList* source_list_new (GtkBin* linked_bin);
SourceList* source_list_construct (GType object_type, GtkBin* linked_bin);
GType source_base_group_get_type (void) G_GNUC_CONST;
void source_base_view_add_group (SourceBaseView* self, SourceBaseGroup* group);
void source_list_add_group (SourceList* self, SourceBaseGroup* group);
gint source_base_view_get_list_width_request (SourceBaseView* self);
void source_base_view_set_list_width_request (SourceBaseView* self, gint value);
static void source_base_view_finalize (GObject* obj);
static void source_base_view_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void source_base_view_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



/**
 * Creates the list and bin widgets. Should be called by subclass
 * constructors.
 */
#line 49 "source-base-view.vala"
SourceBaseView* source_base_view_construct (GType object_type) {
#line 100 "source-base-view.c"
	SourceBaseView * self;
	GtkAlignment* _tmp0_;
	SourceList* _tmp1_;
	self = g_object_newv (object_type, 0, NULL);
#line 52 "source-base-view.vala"
	self->bin = (_tmp0_ = g_object_ref_sink ((GtkAlignment*) gtk_alignment_new ((float) 0, (float) 0, (float) 1, (float) 1)), _g_object_unref0 (self->bin), _tmp0_);
#line 53 "source-base-view.vala"
	self->list = (_tmp1_ = g_object_ref_sink (source_list_new ((GtkBin*) self->bin)), _g_object_unref0 (self->list), _tmp1_);
#line 56 "source-base-view.vala"
	gtk_alignment_set ((GtkAlignment*) self, (float) 0, (float) 0, (float) 1, (float) 1);
#line 111 "source-base-view.c"
	return self;
}


/**
 * Adds a {@link Source.BaseGroup} subclass to this
 * Source.BaseView's {@link Source.List}.
 *
 * @param group The group to add.
 */
#line 65 "source-base-view.vala"
void source_base_view_add_group (SourceBaseView* self, SourceBaseGroup* group) {
#line 65 "source-base-view.vala"
	g_return_if_fail (self != NULL);
#line 65 "source-base-view.vala"
	g_return_if_fail (group != NULL);
#line 67 "source-base-view.vala"
	source_list_add_group (self->list, group);
#line 130 "source-base-view.c"
}


gint source_base_view_get_list_width_request (SourceBaseView* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	result = (g_object_get ((GtkWidget*) self->list, "width-request", &_tmp0_, NULL), _tmp0_);
#line 41 "source-base-view.vala"
	return result;
#line 141 "source-base-view.c"
}


void source_base_view_set_list_width_request (SourceBaseView* self, gint value) {
	g_return_if_fail (self != NULL);
#line 42 "source-base-view.vala"
	g_object_set ((GtkWidget*) self->list, "width-request", value, NULL);
#line 149 "source-base-view.c"
	g_object_notify ((GObject *) self, "list-width-request");
}


static void source_base_view_class_init (SourceBaseViewClass * klass) {
	source_base_view_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->get_property = source_base_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = source_base_view_set_property;
	G_OBJECT_CLASS (klass)->finalize = source_base_view_finalize;
	/**
	 * The width request of this Source.BaseView's {@link Source.List}.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOURCE_BASE_VIEW_LIST_WIDTH_REQUEST, g_param_spec_int ("list-width-request", "list-width-request", "list-width-request", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void source_base_view_instance_init (SourceBaseView * self) {
}


static void source_base_view_finalize (GObject* obj) {
	SourceBaseView * self;
	self = SOURCE_BASE_VIEW (obj);
	_g_object_unref0 (self->bin);
	_g_object_unref0 (self->list);
	G_OBJECT_CLASS (source_base_view_parent_class)->finalize (obj);
}


/**
 * Abstract base for a simple implementation of a widget using
 * {@link Source.List}.
 *
 * Source.BaseView creates a {@link Source.List} and a Gtk.Bin. These can be
 * placed into container widgets by subclasses.
 */
GType source_base_view_get_type (void) {
	static volatile gsize source_base_view_type_id__volatile = 0;
	if (g_once_init_enter (&source_base_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SourceBaseViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_base_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceBaseView), 0, (GInstanceInitFunc) source_base_view_instance_init, NULL };
		GType source_base_view_type_id;
		source_base_view_type_id = g_type_register_static (GTK_TYPE_ALIGNMENT, "SourceBaseView", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&source_base_view_type_id__volatile, source_base_view_type_id);
	}
	return source_base_view_type_id__volatile;
}


static void source_base_view_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SourceBaseView * self;
	self = SOURCE_BASE_VIEW (object);
	switch (property_id) {
		case SOURCE_BASE_VIEW_LIST_WIDTH_REQUEST:
		g_value_set_int (value, source_base_view_get_list_width_request (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void source_base_view_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SourceBaseView * self;
	self = SOURCE_BASE_VIEW (object);
	switch (property_id) {
		case SOURCE_BASE_VIEW_LIST_WIDTH_REQUEST:
		source_base_view_set_list_width_request (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




